
class Calendar {
  constructor (calendarEl, selectedDate) {
    this.calendarEl = calendarEl;
    this.selectedDate = selectedDate;

    function generate_year_range(start, end) {
      var years = "";
      for (var year = start; year <= end; year++) {
        years += "<option value='" + year + "'>" + year + "</option>";
      }
      return years;
    }

    calendarEl.innerHTML = '<div class="button-container-calendar">\n' +
        '<button class="previous-button">&#8249;</button>\n' +
        '    <div class="footer-container-calendar">\n' +
        '      <select class="month-select" >\n' +
        '        <option value=0>Jan</option>\n' +
        '        <option value=1>Feb</option>\n' +
        '        <option value=2>Mar</option>\n' +
        '        <option value=3>Apr</option>\n' +
        '        <option value=4>May</option>\n' +
        '        <option value=5>Jun</option>\n' +
        '        <option value=6>Jul</option>\n' +
        '        <option value=7>Aug</option>\n' +
        '        <option value=8>Sep</option>\n' +
        '        <option value=9>Oct</option>\n' +
        '        <option value=10>Nov</option>\n' +
        '        <option value=11>Dec</option>\n' +
        '      </select>\n' +
        '      <select class="year-select"></select>\n' +
        '    </div>\n' +
        '    <button class="next-button">&#8250;</button>\n' +
        '  </div>\n' +
        '  <table class="table-calendar" id="calendar" data-lang="en">\n' +
        '    <thead class="thead-month"></thead>\n' +
        '    <tbody class="calendar-body"></tbody>\n' +
        '  </table>\n';
    calendarEl.classList.add('container-calendar');
    if (!selectedDate) {
      selectedDate = new Date();
    }
    var currentMonth = selectedDate.getMonth();
    var currentYear = selectedDate.getFullYear();
    var selectYear = calendarEl.querySelector(".year-select");
    var selectMonth = calendarEl.querySelector(".month-select");

    var createYear = generate_year_range(1970, 2050);
    /** or
     * createYear = generate_year_range( 1970, currentYear );
     */

    selectYear.innerHTML = createYear;

    var calendar = calendarEl.querySelector(".table-calendar");
//var lang = calendar.getAttribute('data-lang');

    var months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
    var days = ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"];
    var day;

    var dayHeader = "<tr>";
    for (day = 0; day < days.length; day++) {
      dayHeader += "<th data-days='" + days[day] + "'>" + days[day] + "</th>";
    }
    dayHeader += "</tr>";

    calendarEl.querySelector(".thead-month").innerHTML = dayHeader;


// monthAndYear = document.getElementById("monthAndYear");
    showCalendar(currentMonth, currentYear);



    function next() {
      currentYear = (currentMonth === 11) ? currentYear + 1 : currentYear;
      currentMonth = (currentMonth + 1) % 12;
      showCalendar(currentMonth, currentYear);
    }

    function previous() {
      currentYear = (currentMonth === 0) ? currentYear - 1 : currentYear;
      currentMonth = (currentMonth === 0) ? 11 : currentMonth - 1;
      showCalendar(currentMonth, currentYear);
    }

    function jump() {
      currentYear = parseInt(selectYear.value);
      currentMonth = parseInt(selectMonth.value);
      showCalendar(currentMonth, currentYear);
    }

    function showCalendar(month, year) {

      var firstDay = ( new Date( year, month ) ).getDay();

      var tbl = calendarEl.querySelector(".calendar-body");

      var cell, cellText;

      tbl.innerHTML = "";


      // monthAndYear.innerHTML = months[month] + " " + year;
      selectYear.value = year;
      selectMonth.value = month;

      // creating all cells
      var date = 1;
      for ( var i = 0; i < 6; i++ ) {
        var row = document.createElement("tr");

        for ( var j = 0; j < 7; j++ ) {
          if ( i === 0 && j < firstDay ) {
            cell = document.createElement( "td" );
            cellText = document.createTextNode("");
            cell.appendChild(cellText);
            row.appendChild(cell);
          } else if (date > daysInMonth(month, year)) {
            break;
          } else {
            cell = document.createElement("td");
            cell.setAttribute("data-date", date);
            cell.setAttribute("data-month", month + 1);
            cell.setAttribute("data-year", year);
            cell.setAttribute("data-month_name", months[month]);
            cell.className = "date-picker";
            cell.innerHTML = "<span>" + date + "</span>";

            if ( date === selectedDate.getDate() && year === selectedDate.getFullYear() && month === selectedDate.getMonth() ) {
              cell.className = "date-picker selected";
            }
            row.appendChild(cell);
            date++;
          }


        }

        tbl.appendChild(row);
      }

    }

    function daysInMonth(iMonth, iYear) {
      return 32 - new Date(iYear, iMonth, 32).getDate();
    }

    function dayHandler(ev) {
      let target = ev.target;
      let picker = target.parentElement;
      let selectedEl = calendarEl.querySelector('.selected');
      selectedEl && selectedEl.classList.remove('selected');
      picker.classList.add('selected');
      let d = new Date(picker.getAttribute('data-year'), picker.getAttribute('data-month') - 1, picker.getAttribute('data-date'));
      this.selectedDate = selectedDate = d;
    }

    calendarEl.querySelector('.previous-button').onclick = previous;
    calendarEl.querySelector('.next-button').onclick = next;
    calendarEl.querySelector('.year-select').onchange = jump;
    calendarEl.querySelector('.month-select').onchange = jump;
    calendarEl.querySelector('.calendar-body').onclick = dayHandler;
  }
}

let c = new Calendar(document.getElementById('calendar-anchor'), new Date());
